use clap::Parser;
use serial_comm::protocol::{cmd::Cobs, set_config::SetConfig};

mod cli;

fn main() {
    let args = cli::Cli::parse();

    match args.command {
        cli::Commands::SetConfig(cmd) => {
            let set_config = SetConfig::new(&cmd.key, &cmd.value);
            let (size, set_config): (usize, [u8; 64]) = set_config.as_cobs();

            let builder = serialport::new(&args.port, args.baud);
            let mut port = builder.open().unwrap_or_else(|e| {
                eprintln!("Failed to open {}: {}", &args.port, e);
                ::std::process::exit(1);
            });
            port.write_all(&set_config[..size + 1]).unwrap_or_else(|e| {
                eprintln!("Failed to write command: {}", e);
                ::std::process::exit(1);
            });
        }
    }
}
